# ScpTask

Extends \Task

Copy files to and from a remote host using scp.

Use \Project#createTask to register a new Task.

author | Michiel Rook mrook@php.net
author | Johan Van den Brande johan@vandenbrande.com
version | $Id: 34d699a555092a5473d0636c5e45232dc2019c1d $
package | phing.tasks.ext

### Methods

## Nested adder, adds a set of files (nested fileset attribute).

    addFileSet(\FileSet $fs) : void

### Arguments

#### $fs

`\FileSet`

## copyFile

    copyFile( $local,  $remote)

throws |

### Arguments

#### $local

``

#### $remote

``

## Creates an Ssh2MethodParam object. Handles the <sshconfig /> nested tag

    createSshconfig() : \Ssh2MethodParam

### Response

`\Ssh2MethodParam`

## Returns whether to autocreate remote directories

    getAutocreate()

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## Returns whether to send (default) or fetch files

    getFetch()

## Returns local filename

    getFile()

## Get declared number of successful operations above which "sftp" will be chosen over "scp".

    getHeuristicDecision() : integer

### Response

`integer`

## Returns the remote host

    getHost()

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## Returns the mode value

    getMode()

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Returns the password

    getPassword()

## Returns the remote host port

    getPort()

## Returns the private keyfile

    getPrivkeyfile()

## Returns the private keyfile passphrase

    getPrivkeyfilepassphrase( $privkeyfilepassphrase) : string

### Arguments

#### $privkeyfilepassphrase

``

### Response

`string`

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns the pubkeyfile

    getPubkeyfile()

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## Returns the destination directory

    getTodir()

## Returns the username

    getUsername()

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Perfrom this task

    perform()

inherited

throws |

## Sets whether to autocreate remote directories

    setAutocreate( $autocreate)

### Arguments

#### $autocreate

``

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## Sets whether to send (default) or fetch files

    setFetch( $fetch)

### Arguments

#### $fetch

``

## Sets local filename

    setFile( $file)

### Arguments

#### $file

``

## Declare number of successful operations above which "sftp" will be chosen over "scp".

    setHeuristicDecision(integer $heuristicDecision)

### Arguments

#### $heuristicDecision

`integer`

Number

## Sets the remote host

    setHost( $h)

### Arguments

#### $h

``

## Set level of log messages generated (default = verbose)

    setLevel(string $level)

### Arguments

#### $level

`string`

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the mode value

    setMode( $value)

### Arguments

#### $value

``

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## Sets the password of the user to scp

    setPassword( $password)

### Arguments

#### $password

``

## Sets the remote host port

    setPort( $p)

### Arguments

#### $p

``

## Sets the private key file of the user to scp

    setPrivkeyfile( $privkeyfile)

### Arguments

#### $privkeyfile

``

## Sets the private key file passphrase of the user to scp

    setPrivkeyfilepassphrase( $privkeyfilepassphrase)

### Arguments

#### $privkeyfilepassphrase

``

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Sets the public key file of the user to scp

    setPubkeyfile( $pubkeyfile)

### Arguments

#### $pubkeyfile

``

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

## Set destination directory

    setTodir( $todir)

### Arguments

#### $todir

``

## Sets the username of the user to scp

    setUsername( $username)

### Arguments

#### $username

``

### Properties

## file

    file :

### Type(s)

``

## filesets

    filesets :

### Type(s)

``

## todir

    todir :

### Type(s)

``

## mode

    mode :

### Type(s)

``

## host

    host :

### Type(s)

``

## port

    port :

### Type(s)

``

## methods

    methods :

### Type(s)

``

## username

    username :

### Type(s)

``

## password

    password :

### Type(s)

``

## autocreate

    autocreate :

### Type(s)

``

## fetch

    fetch :

### Type(s)

``

## localEndpoint

    localEndpoint :

### Type(s)

``

## remoteEndpoint

    remoteEndpoint :

### Type(s)

``

## pubkeyfile

    pubkeyfile :

### Type(s)

``

## privkeyfile

    privkeyfile :

### Type(s)

``

## privkeyfilepassphrase

    privkeyfilepassphrase :

### Type(s)

``

## connection

    connection :

### Type(s)

``

## sftp

    sftp :

### Type(s)

``

## counter

    counter :

### Type(s)

``

## logLevel

    logLevel :

### Type(s)

``

## If number of success of "sftp" is grater than declared number decide to skip "scp" operation.

    heuristicDecision : integer

var |

### Type(s)

`integer`

## Indicate number of failures in sending files via "scp" over "sftp"

    heuristicScpSftp : integer

- If number is negative - scp & sftp failed
- If number is positive - scp failed & sftp succeed
- If number is 0 - scp succeed

var |

### Type(s)

`integer`

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`